#-------------------------------------------------------------------------------
# Name:        VerketteteListe.py
# Purpose:     Eine LinkedList Klasse zur Visualisierung der Objektbeziehungen
#              einer dynamischen Datenstruktur im UML-Fenster.
#
# Author:      Gerhard Röhner
#
# Created:     31.01.2022
# Copyright:   (c) 2022
# Licence:     Freeware
# Reference:   https://realpython.com/linked-lists-python/
#-------------------------------------------------------------------------------

class Knoten:
    def __init__(self, Daten):
        self.Daten = Daten
        self.Nächster = None

class VerketteteListe:

    def __init__(self, Knotenliste=None):
        self.Anfang = None
        if Knotenliste is not None:
            einKnoten = Knoten(Knotenliste.pop(0))
            self.Anfang = einKnoten
            for elem in Knotenliste:
                einKnoten.Nächster = Knoten(Daten=elem)
                einKnoten = einKnoten.Nächster

    def einfügen_AmAnfang(self, einKnoten):
        einKnoten.Nächster = self.Anfang
        self.Anfang = einKnoten

    def einfügen_AmEnde(self, einKnoten):
        if self.Anfang is None:
            self.Anfang = einKnoten
        else:
            Cursor = self.Anfang
            while Cursor.Nächster is not None:
                Cursor = Cursor.Nächster
            Cursor.Nächster = einKnoten

    def einfügen_nach(self, Daten, einKnoten):
        Cursor = self.Anfang
        while Cursor is not None and Cursor.Daten != Daten:
            Cursor = Cursor.Nächster
        if Cursor is not None:
            einKnoten.Nächster = Cursor.Nächster
            Cursor.Nächster = einKnoten
        else:
            raise Exception("Knoten mit Daten '%s' nicht gefunden" % Daten)

    def einfügen_vor(self, Daten, einKnoten):
        if self.Anfang.Daten == Daten:
            self.einfügen_amAnfang(einKnoten)
            return

        vorheriger_Knoten = self.Anfang
        Cursor = vorheriger_Knoten.Nächster
        while Cursor is not None and Cursor.Daten != Daten:
            vorheriger_Knoten = Cursor
            Cursor = Cursor.Nächster
        if Cursor is not None:
            einKnoten.Nächster = Cursor
            vorheriger_Knoten.Nächster = einKnoten
        else:
            raise Exception("Knoten mit Daten '%s' nicht gefunden" % Daten)

    def löschen(self, Daten):
        if self.Anfang.Daten == Daten:
            self.Anfang = self.Anfang.Nächster
        else:
            vorheriger_Knoten = self.Anfang
            Cursor = vorheriger_Knoten.Nächster
            while Cursor is not None and Cursor.Daten != Daten:
                vorheriger_Knoten = Cursor
                Cursor = Cursor.Nächster
            if Cursor is not None:
                vorheriger_Knoten.Nächster = Cursor.Nächster

